#coding=utf-8
##从豆瓣网页中得到用户id
##网页地址类型：http://movie.douban.com/subject/20471852/collections?start=0
##              http://movie.douban.com/subject/20471852/collections?start=20
from bs4 import BeautifulSoup
import codecs
import time
import urllib2
 
baseUrl='https://movie.douban.com/subject/20471852/collections?start='
#将用户信息（id，主页链接）保存至文件
def saveUserInfo(idList,linkList):
    if len(idList)!=len(linkList):
        print 'Error: len(idList)!=len(linkList) !'
        return
    writeFile=codecs.open('userIdList.txt','a','utf-8')
    size=len(idList)
    for i in range(size):
        writeFile.write(idList[i]+'\t'+linkList[i]+'\n')
    writeFile.close()
 
#从给定html文本中解析用户id和连接
def parseHtmlUserId(html):
    idList=[]   #返回的id列表
    linkList=[] #返回的link列表
    #把整体的界面传入beautifulSoup 转换分析对象
    soup=BeautifulSoup(html)
    ##<td width="80" valign="top">
    ##<a href="http://movie.douban.com/people/xxxxxx/">
    ##<img class="" src="/" alt="Liar." />
    ##</a>
    ##</td>
    td_tags=soup.findAll('td',width='80',valign='top')
    i=0
    for td in td_tags:
        #前20名用户是看过这部电影的，
        #而后面的只是想看这部电影的用户，因此舍弃
        if i==20:
            break
        a=td.a
        link=a.get('href')
        i_start=link.find('people/')
        id=link[i_start+7:-1]
        idList.append(id)
        linkList.append(link)
        i+=1
    return (idList,linkList)
 
#返回指定编号的网页内容
def getHtml(num):
    url=baseUrl+str(num)
    page=urllib2.urlopen(url)
    html=page.read()
    return html
 
def launch():
    #指定起始编号：20的倍数
    ques=raw_input('Start from number?（Multiples of 20） ')
    startNum=int(ques)
    #做个判断 如果不是20的倍数则不执行
    if startNum%20 != 0:
        print 'Input number error!'
        return
    #从输入的值每隔20计算一次
    for i in range(startNum,200,20):
        print 'Loading page %d/200 ...' %(i+1)
        #获取页面信息
        html=getHtml(i)
        #根据当前页面获取用户ID和用户链接
        (curIdList,curLinkList)=parseHtmlUserId(html)
        #将用户ID和用户链接存到本地文件
        saveUserInfo(curIdList,curLinkList)
        #防止刷新过快被豆瓣封号 程序休眠5秒
        print 'Sleeping .'
        time.sleep(5)
launch()
